package observations;

import java.util.*;

public class CompositeObservation extends Observation
{
  Vector components;

  public CompositeObservation(ObservationType type, Vector observations)
  { obsType = type;
    components = new Vector(observations);
  }

  public boolean isValid()
  {return obsType.isValid(this);}

  public void value(Vector values)
  { if (values.size()==components.size())
    { int index = 0;
      Enumeration enum = values.elements();
      while( enum.hasMoreElements())	
      { 
	  Object element = enum.nextElement();
//        System.out.println("type: "+element.getClass().getName());
//        System.out.println("value: "+(Float)element);
        if (element.getClass().getName().equals("java.lang.String"))
	    ((ValueHandling)components.elementAt(index)).value((String)element); 
        if (element.getClass().getName().equals("java.lang.Float"))
	    ((ValueHandling)components.elementAt(index)).value((Float)element); 
        if (element.getClass().getName().equals("java.util.Vector"))
	    ((ValueHandling)components.elementAt(index)).value((Vector)element); 
         
        index++;
      } 
    }
  }

  public Object value()
  { Vector result = new Vector();
    Enumeration enum = components.elements();
    while( enum.hasMoreElements())	
    { result.addElement( ((ValueHandling)enum.nextElement()).value() );}
    return result;
  }
} 
