package observations;

import java.util.*;
import java.lang.*;

public class PrimitiveObservationType extends ObservationType implements ObservationFactory
{
  public PrimitiveObservationType(Validator aValidator, String aName)
  { validator = aValidator;
    name = aName;
  }

  public Observation createObservation()
  { return new PrimitiveObservation(this); }

  public boolean isValid(PrimitiveObservation observation)
  { 
    Class valueClass = observation.value.getClass();
    if (valueClass.getName().equals( "java.lang.String"))
      return (validator.isValid((String)observation.value));
    if (valueClass.getName().equals("java.lang.Float"))
      return (validator.isValid((Float)observation.value));
    return false;
  }

 
} 
