
package observations;

import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.URL;
import java.net.MalformedURLException;

import org.xml.sax.Parser;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.ParserFactory;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

public class XMLMetadataReader {

public static void traverse(org.w3c.dom.Node node, Hashtable result, Vector filters)
{
  if (node == null)
  { return ; }


  int type = node.getNodeType();
  switch (type)
  {
    // print document
    case Node.DOCUMENT_NODE:
    {
       traverse(((Document)node).getDocumentElement(), result, filters);
       break;
    }

    // print element with attributes

    case Node.ELEMENT_NODE:
    case Node.ENTITY_REFERENCE_NODE:
    {
       NodeList children = node.getChildNodes();
       if (filters.contains(node.getNodeName()))
       {  
          
          if (children != null)
          {
            String fieldValue ="";
            int len = children.getLength();
            for (int i = 0; i < len; i++)
               fieldValue += fetch(children.item(i));
            result.put(node.getNodeName(), fieldValue);
//	    result.removeFirst();
          }
       }
       else
       {
          if (children != null)
          {
            int len = children.getLength();
            for (int i = 0; i < len; i++)
               traverse(children.item(i), result, filters);                  
          }
       }

       break;
    }

     case Node.CDATA_SECTION_NODE:
     case Node.TEXT_NODE:
     {  //this text has to be ignored since the parent wasn't part of filters
        break;
     }
  }
}



private static String fetch(org.w3c.dom.Node node)
{
  if (node == null)
  { return ""; }

  String result = "";
  int type = node.getNodeType();
  switch (type)
  {
     default:
     {
        NodeList children = node.getChildNodes();
        if (children != null)
        {
           int len = children.getLength();
           for (int i = 0; i < len; i++) 
              result += fetch(children.item(i) );
        }            
        break;
     }
     // print text
     case Node.CDATA_SECTION_NODE:
     case Node.TEXT_NODE:
     {  
        if (node.getNodeValue() != null)
          result += node.getNodeValue();
        break;
     }
  }
  return result;
}


}













